#pragma once

#include "CoreMinimal.h"
#include "StunnableInterface.h"
#include "Components/ActorComponent.h"
#include "Templates/SubclassOf.h"
#include "DBDTunableRowHandle.h"
#include "K38DogStunnableComponent.generated.h"

class UStatusEffect;

UCLASS(Blueprintable, meta=(BlueprintSpawnableComponent))
class UK38DogStunnableComponent : public UActorComponent, public IStunnableInterface
{
	GENERATED_BODY()

protected:
	UPROPERTY(EditAnywhere, BlueprintReadWrite)
	TSubclassOf<UStatusEffect> _killerInstinctEffectClass;

	UPROPERTY(EditAnywhere, BlueprintReadWrite)
	FDBDTunableRowHandle _killerInstinctFromDogStunDuration;

private:
	UPROPERTY(EditAnywhere, BlueprintReadWrite, meta=(AllowPrivateAccess=true))
	FDBDTunableRowHandle _stunDogScoreReductionPointThreshold;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, meta=(AllowPrivateAccess=true))
	FDBDTunableRowHandle _stunDogScoreReductioPercentage;

public:
	UK38DogStunnableComponent();
};

FORCEINLINE uint32 GetTypeHash(const UK38DogStunnableComponent) { return 0; }
